
c     The program "err_codes" detects some netCDF error codes
c     which may be of use when checking prior existence of
c      * a  dimension
c      * a  variable
c      * an attribute


      program err_codes

      implicit none

      include 'netcdf.inc'

      integer n
      parameter (n = 1)

      integer nc_status,nc_id,dim_id,var_id,no,
     >        no_dim_match,no_var_match,no_att_match


      nc_status = NF_CREATE('err_codes.nc', NF_NOCLOBBER, nc_id)
      if (nc_status .ne. NF_NOERR) call handle_err(nc_status,1)


c     --- START consider dimension ---

c     Set 'no_dim_match':
      no_dim_match = NF_INQ_DIMID(nc_id, 'a_dimension', dim_id)

c     Define dimension:
      nc_status = NF_DEF_DIM(nc_id, 'a_dimension', n, dim_id)
      if (nc_status .ne. NF_NOERR) call handle_err(nc_status,2)

c     --- END consider dimensions ---


c     --- START consider variable ---

c     Set 'no_var_match':
      no_var_match = NF_INQ_VARID(nc_id, 'a_variable', var_id)

c     Define variable:
      nc_status = NF_DEF_VAR(nc_id, 'a_variable', NF_INT, 1, n, var_id)
      if (nc_status .ne. NF_NOERR) call handle_err(nc_status,3)

c     --- END consider variable ---


c     --- START consider attributes ---

c     Set 'no_att_match':
      no_att_match = NF_INQ_ATTID(nc_id, var_id, 'an_attribute', no)

c     --- END consider attribute ---


      nc_status = NF_CLOSE(nc_id)
      if (nc_status .ne. NF_NOERR) call handle_err(nc_status,3)


c     --- START write error codes to "include"-file ---

      open(31, file= 'err_codes.inc', status= 'unknown',
     >         access= 'sequential', form= 'formatted')

 100  format(6x,a46)
      write(31,100)'integer no_dim_match,no_var_match,no_att_match'

 102  format(6x,a11)
      write(31,102)'parameter ('

 103  format(5x,a1,11x,a14,i4,a1)
      write(31,103)'>','no_dim_match= ',no_dim_match,','
      write(31,103)'>','no_var_match= ',no_var_match,','
      write(31,103)'>','no_att_match= ',no_att_match,')'

c     --- END write error codes to "include"-file ---


      open(41, file= 'ok_flag', status='unknown')
      close(41)


      end
